<?php
/**
 * WordpressIDX plugin related constants.  These are used in many
 * different classes.
 *
 * @author wordpressIDX
 */
if( !interface_exists('wordpressIDXConstants')){
	interface wordpressIDXConstants{

		const VERSION="1.4.2";
		const EXTERNAL_URL= "http://www.idxre.com/services/wordpress";

		//Group for Activation related options
		//Also used as menu slug for the Activate Menu
		const OPTION_ACTIVATE="wpidx-option-activate";
		//menu slug for information page
		const INFORMATION="wpidx-information" ;
		//Menu slug for the option pages
		const OPTION_PAGES="wpidx-option-pages";
		//Group for Bio related options
		const OPTION_GROUP_BIO="wpidx-option-bio";		
		//Group for Social related options
		const OPTION_GROUP_SOCIAL="wpidx-option-social";
		//Group for Email Display related options		
		const OPTION_GROUP_EMAIL_DISPLAY="wpidx-option-email-display";
		//Group for SEO City Links related options		
		const OPTION_GROUP_SEO_CITY_LINKS="wpidx-option-seo-city-links";

		
		//Community Pages setup
		const COMMUNITY_PAGES="wpidx-community-pages";
				
		//Bio Information setup
		const AGENT_PHOTO_OPTION="wpidx-bio-agent-photo-option";		
		const AGENT_TEXT_OPTION="wpidx-bio-agent-text-option";
		const AGENT_DESIGNATIONS_OPTION="wpidx-bio-agent-designations-option";
		const AGENT_DISPLAY_TITLE_OPTION="wpidx-agent-display-title-option";
		const AGENT_LICENSE_INFO_OPTION="wpidx-agent-license-info-option";

		const CONTACT_PHONE_OPTION="wpidx-bio-contact-phone";		
		const CONTACT_EMAIL_OPTION="wpidx-bio-contact-email";	
		
		const OFFICE_LOGO_OPTION="wpidx-bio-office-logo";
		
		
		//Social related settings
		const FACEBOOK_URL_OPTION="wpidx-social-facebook-url-option";
		const LINKEDIN_URL_OPTION="wpidx-social-linkedin-url-option"; 		
		const TWITTER_URL_OPTION="wpidx-social-twitter-url-option";
		
		//Email Display related settings
		const EMAIL_HEADER_OPTION="wpidx-email-display-header-option";
		const EMAIL_FOOTER_OPTION="wpidx-email-display-footer-option";
		const EMAIL_PHOTO_OPTION="wpidx-email-photo-option";
		const EMAIL_LOGO_OPTION="wpidx-email-logo-option";
		const EMAIL_NAME_OPTION="wpidx-email-name-option";
		const EMAIL_COMPANY_OPTION="wpidx-email-company-option";
		const EMAIL_ADDRESS_LINE1_OPTION="wpidx-email-address-line1-option";
		const EMAIL_ADDRESS_LINE2_OPTION="wpidx-email-address-line2-option";
		const EMAIL_PHONE_OPTION="wpidx-email-phone-option";
		
		const EMAIL_DISPLAY_TYPE_OPTION="wpidx-email-display-type-option";
		
		//SEO City Links settings
		const SE0_CITY_LINKS_SETTINGS="wpidx-seo-city-links-settings";
		const SE0_CITY_LINKS_CITY_ZIP="wpidx-seo-city-links-city-zip";
		const SE0_CITY_LINKS_TEXT="wpidx-seo-city-links-text";
		const SE0_CITY_LINKS_MIN_PRICE="wpidx-seo-city-links-min-price";
		const SE0_CITY_LINKS_MAX_PRICE="wpidx-seo-city-links-max-price";
		const SE0_CITY_LINKS_PROPERTY_TYPE="wpidx-seo-city-links-property-type";
		const SE0_CITY_LINK_WIDTH = "wpidx-seo-city-link-width";
		
		
		
		//Activation related options EMAIL_DISPLAY_TYPE_OPTION
		const ACTIVATION_TOKEN_OPTION="wpidx_activation_token";
		const ACTIVATION_DATE_OPTION="wpidx_activation_date";

		//Group for configuration related options
		//Also menu slug for the configuration page
		const OPTION_CONFIG_PAGE="wpidx-config-page";
		//Configuration realted option
		const CSS_OVERRIDE_OPTION="wpidx-css-override";
		
		//Bio related options page
		const BIO_PAGE="wpidx-bio-page";

		//Social related options page
		const SOCIAL_PAGE="wpidx-social-page";
		
		//Email Display related options page
		const EMAIL_BRANDING_PAGE="wpidx-email-branding-page";
		
		const SEO_CITY_LINKS_PAGE="wpidx-seo-city-links-page";
		
        const VERSION_OPTION="wpidx_version_option";

		//Transient value - cached authentication token
		const AUTHENTICATION_TOKEN_CACHE="wpidx_authentication_token";
		//Number of seconds for transient to timeout 60*60=3600=1 hour
		//const AUTHENTICATION_TOKEN_CACHE_TIMEOUT=3600;

		//Remember if this plugin has ever been activated on this site.
		//This affects things like link creation, when the plugin is activated.
		const IS_ACTIVATED_OPTION="wpidx_links_created";

		//Used throughout the application to discover WordpressIDX requests
		//and used to determin the proper filter to execute.
		const wpidx_TYPE_URL_VAR='wpidx-type';

		///////////////////////////////////////////////////////
		//Transient Values
		const PROPERTY_GALLERY_CACHE = "wpidx_property_gallery_cache";
		//Number of seconds for transient to timeout 60*60*24= 86400 = 1 day
		//Number of seconds for transient to timeout 60*30= 86400 = 30 minutes
		const PROPERTY_GALLERY_CACHE_TIMEOUT = 1800 ;
		///////////////////////////////////////////////////////


		//Used to set the widget context.
		//A search widget should not display on a
		//search related virtual page
		const SEARCH_WIDGET_TYPE="searchWidget";
		const GALLERY_WIDGET_TYPE="galleryWidget";

		const DEBUG = false;
	}
}
?>
