<?php
if( !class_exists('wordpressIDXMapSearchVirtualPageImpl')) {
	
	class wordpressIDXMapSearchVirtualPageImpl implements wordpressIDXVirtualPage {
		
		private $path="homes-for-sale-map-search";
		private $title="Map Search";
	
		public function __construct(){
			
		}
		public function getTitle(){
			$customTitle = get_option(wordpressIDXVirtualPageHelper::OPTION_VIRTUAL_PAGE_TITLE_MAP_SEARCH);
			if( $customTitle != null && "" != $customTitle ){
				$this->title=$customTitle ;
			}
			return $this->title;
		}
	
		public function getPageTemplate(){
			$pageTemplate = get_option(wordpressIDXVirtualPageHelper::OPTION_VIRTUAL_PAGE_TEMPLATE_MAP_SEARCH);
			return $pageTemplate;			
		}
		
		public function getPath(){
			$customPath = get_option(wordpressIDXVirtualPageHelper::OPTION_VIRTUAL_PAGE_PERMALINK_TEXT_MAP_SEARCH );	
			if( $customPath != null && "" != $customPath ){
				$this->path = $customPath ;
			}
			return $this->path;
		}
		
				
		public function getContent( $authenticationToken ){
			wordpressIDXLogger::getInstance()->debug('Begin wordpressIDXMapSearchVirtualPageImpl->getContent');
			
			$wpidxUrl = WordpressIDXConstants::EXTERNAL_URL 
			    . '?method=handleRequest&viewType=json'
			    . '&requestType=map-search-widget'
			    . '&authenticationToken=' 
				. $authenticationToken
	            . '&width=595'
	            . '&height=500';
            $contentInfo = WordpressIDXRequestor::remoteRequest($wpidxUrl);
            $content = wordpressIDXRequestor::getContent( $contentInfo );
			
			wordpressIDXLogger::getInstance()->debug('End wordpressIDXMapSearchVirtualPageImpl->getContent');
			wordpressIDXLogger::getInstance()->debug('<br/><br/>' . $wpidxUrl);
			return $content ;
		}
	}
}
?>